# -*- coding: utf-8 -*-
##*********************************************************
#   medical_check prediction (dnn)  ver.1                 *
#        copyright M .Kogoshi & S. Kogoshi                *
##*********************************************************

import keras
from keras.models import Sequential
from keras.layers import Dense, Activation, Dropout
import numpy as np
import matplotlib.pyplot as plt
import sys
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.metrics import mean_squared_error


#保存ファイル
savefile = "test0503r.h5"

# load of data
data_set = pd.read_csv("medical_check.csv",sep=",",header=0)

#separation of input(x) and target(y)
x = pd.DataFrame(data_set.drop("Blood pressure risk",axis=1))
#x = pd.DataFrame(x1.drop("lnROS",axis=1))
y = pd.DataFrame(data_set["Blood pressure risk"])


#y_train creation for comparison
y2 = np.array(y.T)
y = y2[0]

# standardization of x
scaler = StandardScaler()
scaler.fit(x)
x_train = scaler.transform(x)


# input and output for keras
x_train = x_train.astype(np.float)

X = x_train
#y = y_train

# number,dimensio,class_number
(n_samples, n_features) = X.shape

# 4 layers
model = Sequential()
# input layer
model.add(Dense(units=50, activation='relu', input_shape=(n_features,)))
# Dropout
model.add(Dropout(0.1))
# second layer
model.add(Dense(units=20, activation='relu'))
# Dropout
model.add(Dropout(0.1))
# output layer
model.add(Dense(1))
model.summary

# compile
model.compile(loss='mean_squared_error', optimizer='adam', metrics=['mae'])

# learning
history = model.fit(X, y, epochs=500, batch_size=16, verbose=2)

# save model
model.save_weights(savefile)

#loss_graph
plt.xlabel('time step')
plt.ylabel('loss')
plt.ylim(0,100)
loss, = plt.plot(history.history['loss'], c='#E69F00')
plt.show()

# load of new_data
new_data = pd.read_csv("aomori.csv",sep=",",header=0)

x1 = pd.DataFrame(new_data.drop("Blood pressure risk",axis=1))
#y_test=pd.DataFrame(new_data["Blood pressure risk"])

x_axis = pd.DataFrame(new_data["Smoking rate"])

#change to form of DataFrame
x = pd.DataFrame(x1)


# standardization of x
x_test = scaler.transform(x)


# result
y_pred = model.predict(x_test, verbose=0)

#mse = mean_squared_error(y_test,y_pred)

# csv output of test result
x_axis = np.array(x_axis)
data1 = np.c_[x_axis, y_pred]
data1 = pd.DataFrame(data1)
np.savetxt('out.csv', data1, delimiter=',')


plt.xlabel('Percentage of smoking(%)')
plt.ylabel('predicted_blood_prssure_risk(%)')
plt.xlim(30,50)
plt.ylim(30,50)

plt.scatter(x_axis,y_pred,s=5)
plt.show()

#print("KERAS RMSE: %.2f" %(mse**0.5))
print("END")